# Headquarters

Issue commands to your program while it is running.

## Installation

```
$ npm install --save headquarters
```

```
var hq = require('headquarters');
```

## Usage

```
hq.command(name, action);
```

Sets a command.

Parameters

* **name** the name of the command (*string*)
* **action** called whe the command is issued (*function*)

Type your command *name* in the console as your program is running followed by any additional parameters. The *action* function for that command will then be executed, with the additional parameters passed into the first argument of the function as an array.

## Example

```
var hq = require('headquarters');

hq.command('say', function (params) {
	console.log(params.join(' '));
});
```

In the command line, start your program:

```
$ node my_program.js
```

Then use your custom command:

```
say hello world!
```

Profit:

```
hello world!
```

## Pre-existing Commands

Commands that are already built into headquarters:

* **'quit'** stops your process from running
* **'curl'** retrieves a response from a url argument
