var request = require('request');

function input() {

	// Scope globals

	var rawAction;
	var commands = {};

	// Pre-determined messages

	var msg = {
		error: {
			noSuchCommand: 'Error: That command is not set'
		}
	}

	// External functions

	this.raw = function(action) {
		rawAction = action;
	}

	this.command = function(name, action) {
		addCommand(name, action);
	}

	// Internal functions

	function addCommand(name, action) {
		commands[name] = action;
	}

	// Initialization

	function init() {
		process.stdin.resume();
		process.stdin.setEncoding('utf8');
		process.stdin.on('data', function (input) {
			input = input.split('\n')[0];
			var data = input.split(' ');
			var rawData = data;
			var name = data.shift();
			if (typeof commands[name] !== 'undefined') commands[name](data);
			else if (rawAction) rawAction(rawData);
			else console.log(msg.error.noSuchCommand);
		});

		addCommand('quit', function() {
			process.exit();
		});

		addCommand('curl', function(args) {
			request(args[0].toString(), function(err, response, body) {
				console.log(response);
			});
		});
	}

	init();

	return this;
}

// Exports

module.exports = new input();